//
//  EventPoller.h
//  StreamSDKConLib
//
//  Copyright (c) 2014 StreamUnlimited. All rights reserved.
//

#ifndef __StreamSDKConLib__EventPoller__
#define __StreamSDKConLib__EventPoller__

#include "EventHandler.h"

namespace Poco {
    class NotificationCenter;
    class Timer;
}

namespace StreamUnlimited { namespace StreamAPI {
    class EventPoller {
    private:
        const static Poco::Int32 _defaultInterval = 1000;

        Poco::NotificationCenter *_notificationCenter;
        Poco::Timer *_queuePollingTimer;
        Poco::Timer *_queueUpdateTimer;
        std::string  _currentPath;
        std::string  _currentContextMenuPath;
        EventHandler _handler;
        EventPoller(const EventPoller&);
        EventPoller& operator=(const EventPoller&);

    public:
        explicit EventPoller(Poco::NotificationCenter *nc);
        ~EventPoller();

        void connect(const std::string &host, Poco::UInt16 port);
        void disconnect();

        bool startPolling();
        bool stopPolling();

        void pause();
        void unpause();

        void modifyPathSubscription(const std::string &subscribePath, const std::string &unsubscribePath);

        void requestPlayData();
        std::string getContextMenuPath();

    private:
        void setPollingInterval(Poco::Int32 milliseconds);
    };
} }

#endif /* defined(__StreamSDKConLib__EventPoller__) */
