//
//  includes.h
//  StreamSDKConLib
//
//  Copyright (c) 2014 StreamUnlimited. All rights reserved.
//

#ifndef __StreamSDKConLib__includes__
#define __StreamSDKConLib__includes__

#include <string>
#include <sstream>
#include "platform.h"

#define DBG_LEVEL DBG_TRACE

#if defined(_WIN64) || defined(_WIN32)
    /* Microsoft Windows. ------------------------------ */
	#define PATH_DELIMITER '\\'
#else
	#define PATH_DELIMITER '/'
#endif

#define __NICE_FILE__ (strrchr(__FILE__, PATH_DELIMITER) ? strrchr(__FILE__, PATH_DELIMITER) + 1 : __FILE__)

#define DEBUG_PRINT(logLevel, levelString, module, function, aWhat) \
{ \
    std::ostringstream ods_stream_; \
    ods_stream_ << levelString << module << "::" << function << "   " << aWhat << std::endl; \
    printConsole(logLevel, "%s", ods_stream_.str().c_str() ); \
}

#define _TRACE_(aWhat) if (( DBG_LEVEL <= DBG_TRACE )) DEBUG_PRINT(DBG_TRACE, "TRACE: " , __NICE_FILE__, __FUNCTION__, aWhat)
#define _DEBUG_(aWhat) if (( DBG_LEVEL <= DBG_DEBUG )) DEBUG_PRINT(DBG_DEBUG, "DEBUG: " , __NICE_FILE__, __FUNCTION__, aWhat)
#define _INFO_(aWhat)  if (( DBG_LEVEL <= DBG_INFO  )) DEBUG_PRINT(DBG_INFO,  "INFO:  " , __NICE_FILE__, __FUNCTION__, aWhat)
#define _ERROR_(aWhat) if (( DBG_LEVEL <= DBG_ERROR )) DEBUG_PRINT(DBG_ERROR, "ERROR: " , __NICE_FILE__, __FUNCTION__, aWhat)

#endif /* defined(__StreamSDKConLib__includes__) */
