//
//  sdk_includes.h
//  StreamSDKConLib
//
//  Copyright (c) 2014 StreamUnlimited. All rights reserved.
//

#ifndef __StreamSDKConLib__Roles__
#define __StreamSDKConLib__Roles__

#define ROLES_ID            "id"
#define ROLES_TITLE         "title"
#define ROLES_PATH          "path"
#define ROLES_RESOURCES     "resources"
#define ROLES_QUERY         "query"
#define ROLES_VALUE         "value"
#define ROLES_ACTIVATE      "activate"
#define ROLES_ICON          "icon"
#define ROLES_TYPE          "type"
#define ROLES_AUDIO_TYPE    "audioType"
#define ROLES_FLAGS         "flags"
#define ROLES_CONTEXT       "context"
#define ROLES_DESCRIPTION   "description"
#define ROLES_INDEX         "index"
#define ROLES_STATE         "state"
#define ROLES_STATUS        "status"
#define ROLES_EDIT          "edit"
#define ROLES_ARTIST        "artist"
#define ROLES_ALBUM         "album"
#define ROLES_CONTEXT_PATH  "contextPath"
#define ROLES_MEDIA_DATA    "mediaData"
#define ROLES_MEDIA_ROLES   "mediaRoles"
#define ROLES_TRACK_ROLES   "trackRoles"
#define ROLES_META_DATA     "metaData"
#define ROLES_MODIFIABLE    "modifiable"
#define ROLES_SEARCH        "search"
#define ROLES_CANCEL        "cancel"
#define ROLES_ACCEPT        "accept"
#define ROLES_DISABLED      "disabled"
#define ROLES_CONTAINERTYPE "containerType"
#define ROLES_CONTAINER_PLAYABLE "containerPlayable"
#define ROLES_RELEASE_DATE "releaseDate"
#define ROLES_PERSISTENT_META_DATA "persistentMetaData"
#define ROLES_DO_NOT_TRACK "doNotTrack"
#define ROLES_RENDER_AS_BUTTON "renderAsButton"
#define ROLES_AUDIO_TYPE "audioType"
#define ROLES_ALL_ROLES     "title,icon,type,containerType,containerPlayable,personType,albumType,imageType,audioType,videoType,epgType,modifiable,disabled,flags,path,value,valueOperation(),edit,mediaData,query,activate,likeIt,rowsOperation,setRoles,timestamp,id,valueUnit,context,description,longDescription,search,valueBlob,prePlay,activity,cancel,accept,risky,preferred,httpRequest,encrypted,encryptedValue,rating,fillParent,autoCompletePath,busyText,sortKey,renderAsButton,doNotTrack,persistentMetaData,releaseDate,audioType"

#define ROLES_URI           "uri"

#define VALUE_TYPE_STRING   "string_"
#define VALUE_TYPE_BOOL     "bool_"
#define VALUE_TYPE_ENUM     "enum_"
#define VALUE_TYPE_SLIDER   "slider"
#define VALUE_TYPE_PASSWORD "password"
#define VALUE_TYPE_TIME     "time"
#define VALUE_TYPE_DATE     "date"
#define VALUE_TYPE_NUMBER   "number"
#define VALUE_TYPE_I16      "i16_"
#define VALUE_TYPE_I32      "i32_"
#define VALUE_TYPE_I64      "i64_"
#define VALUE_TYPE_DOUBLE   "double_"
#define VALUE_TYPE_MIN      "min"
#define VALUE_TYPE_STEP     "step"
#define VALUE_TYPE_MAX      "max"
#define VALUE_TYPE_GROUPINGREQUEST  "groupingRequest"
#define VALUE_TYPE_GROUPINGGROUP    "groupingPersistentGroup"

#define VALUE_TRUE              "true"
#define VALUE_FALSE             "false"

#define CONTAINER_TYPE_ALERT    "alert"

#define ROWTYPE_AUDIO           "audio"
#define ROWTYPE_VIDEO           "video"
#define ROWTYPE_PLAYLIST        "playlist"
#define ROWTYPE_IMAGE           "image"
#define ROWTYPE_SPACER          "spacer"
#define ROWTYPE_HEADER          "header"
#define ROWTYPE_QUERY           "query"
#define ROWTYPE_VALUE           "value"

#define STR_ENUMVALUES          "enumValues"
#define STR_VALUEPATH           "valuePath"

#define REPLY_NSDKACTION        "NsdkActionReply"
#define REPLY_NULL              "null"
#define REPLY_JSONARRAYEMPTY    "[]"
#define REPLY_JSONARRAYNULL     "[null]"

#define REPLY_RESULT            "result"
#define REPLY_EVENTS            "events"
#define REPLY_ERROR             "error"
#define REPLY_ERROR_NAME        "name"
#define REPLY_ERROR_MESSAGE     "message"
#define REPLY_ERROR_TITLE       "title"

#define EVENT_ROWSTYPE          "rowsType"
#define EVENT_REMOVE            "remove"
#define EVENT_CLOSE_CONTEXT     "globalCloseContextMenu"

// important paths
#define HOME_PATH               "/ui"
#define STANDBY_PATH            "powermanager:target"
#define STANDBY_SET_PATH        "powermanager:targetRequest"
#define MUTE_PATH               "settings:/mediaPlayer/mute"
#define VOLUME_PATH             "player:volume"
#define PLAYER_CONTROL_PATH     "player:player/control"
#define PLAYER_PLAY_MODE_PATH   "settings:/mediaPlayer/playMode"
#define PLAYER_PLAY_TIME_PATH   "player:player/data/playTime"
#define PLAYER_PLAY_DATA_PATH   "player:player/data"
#define DEVICE_NAME             "settings:/deviceName"
#define DEVICE_ID               "settings:/system/memberId"
#define TUNNELING_PATH          "/tunneling/data"
#define NOTIFICATIONS_PATH      "notifications:/display/queue"
#define CANCEL_PATH             "notifications:/display/cancel"

#define GROUPING_REQUEST            "grouping:request"
#define GROUPING_SAVE_PERSISTENT    "grouping:savePersistentGroup"
#define GROUPING_MEMBERS            "grouping:members"

#define PLAYLISTS_PL_GETPLAYLISTS         "playlists:pl/getlist"
#define PLAYLISTS_PL_GETPLAYQUEUE         "playlists:pq/getitems" //Still needs to be changed

#define PLAYLISTS_PL_CREATE_PATH          "playlists:pl/create"
#define PLAYLISTS_PL_DELETE_PATH          "playlists:pl/delete"
#define PLAYLISTS_PL_CLEAR_PATH           "playlists:pl/clear"
#define PLAYLISTS_PL_SETNAME_PATH         "playlists:pl/setname"
#define PLAYLISTS_PL_SETSHUFFLE_PATH      "playlists:pl/setshuffle"
#define PLAYLISTS_PL_SETREPEAT_PATH       "playlists:pl/setrepeat"
#define PLAYLISTS_PL_MOVEITEM_PATH        "playlists:pl/moveitem"
#define PLAYLISTS_PL_ADDITEMS_PATH        "playlists:pl/additems"
#define PLAYLISTS_PL_REMOVEITEMS_PATH     "playlists:pl/removeitems"

#define PLAYLISTS_CL_CREATE_PATH          "playlists:cl/create"
#define PLAYLISTS_CL_DELETE_PATH          "playlists:cl/delete"
#define PLAYLISTS_CL_SETNAME_PATH         "playlists:cl/setname"
#define PLAYLISTS_CL_ADDPLAYLIST_PATH     "playlists:cl/addplaylist"
#define PLAYLISTS_CL_REMOVEPLAYLIST_PATH  "playlists:cl/removeplaylist"

#define AVS_STATUS_PATH                   "avs:status"
#define AMAZON_LOGGED_IN_PATH             "loginwithamazon:/loggedIn"
#define AMAZON_LOGOUT_PATH                "loginwithamazon:/removeToken"

#ifdef USE_NSDK_AMAZON_LOGIN
#define AMAZON_COMPANION_URL_PATH         "settings:/loginWithAmazon/companionUrl"
#define AMAZON_LOGIN_BLOB_PATH            "loginwithamazon:/loginBlob"
#define AMAZON_SET_TOKEN_BLOB_PATH        "loginwithamazon:/setTokenBlob"
#else
#define AMAZON_DEVICE_INFO_PATH           "loginwithamazon:/appDeviceInfo"
#define AMAZON_SET_CODE_PATH              "loginwithamazon:/appSetCode"
#endif

extern const char *PlayModeStrings[];
extern const char *GroupingCommandStrings[];
extern const char *StreamAPICommandStrings[];

#endif /* defined(__StreamSDKConLib__Roles__) */
